<?php
// Sécurité
define('OK',1);
// Configuration
include('config.php');
// Fonctions
include('fonctions.php');

// Vérification du token CSRF
//if ( !isset($_REQUEST['csrf-token']) || isset($_SESSION['csrf-token']) && ( $_REQUEST['csrf-token'] != $_SESSION['csrf-token'] ) )
//  exit('{"etat":"nok","message":"Accès non autorisé"}');

// Reconnexion demandée si déconnecté
if ( $autorisation == 0 )
  exit('{"etat":"login"}');

// Récupération de l'action
if ( !isset($_REQUEST['action']) || !in_array($action = $_REQUEST['action'],array('docs','prefs','compteglobal','transdocs','commentairescolles','listeprofs'),true) )
  exit('{"etat":"nok","message":"Mauvais paramètrage"}');

///////////////////////////////////////////////
// Récupération des répertoires et documents //
///////////////////////////////////////////////
if ( ( $action == 'docs' ) )  {

  $mysqli = connectsql();
  $resultat = $mysqli->query("SELECT m.id AS mid, m.nom AS mnom, r.id AS rid, d.id AS did, CONCAT(d.nom,IF(LENGTH(d.ext),CONCAT(' (',d.ext,')'),'')) AS dnom, 
                                     CONCAT_WS('/', ( SELECT GROUP_CONCAT(reps.nom ORDER BY FIND_IN_SET(reps.id,r.parents) SEPARATOR '/') FROM reps WHERE FIND_IN_SET(reps.id,r.parents) ), r.nom) AS rnom
                                     FROM docs AS d LEFT JOIN reps AS r ON r.id = d.parent LEFT JOIN ( (SELECT id, ordre, nom FROM matieres) UNION (SELECT 0, 0, 'Documents généraux') ) AS m ON m.id = r.matiere 
                                     WHERE FIND_IN_SET(m.id,'${_SESSION['matieres']}') AND ".requete_protection($autorisation,'d.').' ORDER BY m.ordre, rnom, nom_nat');
  if ( $resultat->num_rows )  {
    $mats = '<option value="-1">[Choisissez une matière]</option>';
    $reps = array( -1 =>'<option value="-1">[Choisissez une matière]</option>');
    $docs = array( -1 => '<option value="0">[Choisissez une matière]</option>', 0 => '<option value="0">[Choisissez un répertoire]</option>' );
    $mid = $rid = -1;
    while ( $r = $resultat->fetch_assoc() )  {
      if ( $r['mid'] != $mid )  { 
        $mid = $r['mid'];
        $mats .= "<option value=\"$mid\">${r['mnom']}</option>";
        $reps[$mid] = '<option value="0">[Choisissez un répertoire]</option>';
      }
      if ( $r['rid'] != $rid )  { 
        $rid = $r['rid'];
        $reps[$mid] .= "<option value=\"$rid\">${r['rnom']}</option>";
        $docs[$rid] = '<option value="0">[Choisissez un document]</option>';
      }
      $docs[$rid] .= "<option value=\"${r['did']}\">${r['dnom']}</option>";
    }
    $resultat->free();
  }
  exit(json_encode(array('recupok'=>1,'mats'=>$mats,'reps'=>$reps,'docs'=>$docs)));

}

///////////////////////////////////////////////
// Récupération des données d'un utilisateur //
///////////////////////////////////////////////
elseif ( ( $action == 'prefs' ) && $_SESSION['admin'] && connexionlight() && isset($_REQUEST['id']) && ctype_digit($id = $_REQUEST['id']) )  {

  // Vérification que l'identifiant est valide
  $mysqli = connectsql();
  $resultat = $mysqli->query("SELECT nom, prenom, login, matieres, mail as mail1, (LENGTH(mdp)=40) AS valide, (LEFT(mdp,1)='*') AS demande, (LENGTH(mdp)=1) AS invitation, autorisation%10 AS autorisation, autorisation>10 AS admin, mailexp, mailcopie FROM utilisateurs WHERE id = $id");
  if ( $resultat->num_rows )  {
    $r = $resultat->fetch_assoc();
    $resultat->free();
    // Problème d'encodage des entiers, renvoyés en tant que chaîne.
    // Semble dépendre du driver MySQL, ne prenons pas de risque
    $r['valide'] = intval($r['valide']);
    $r['demande'] = intval($r['demande']);
    $r['invitation'] = intval($r['invitation']);
    $r['autorisation'] = intval($r['autorisation']);
    $r['admin'] = intval($r['admin']);
    $r['mailcopie'] = intval($r['mailcopie']);
    // Récupération des autorisations d'envoi
    $resultat = $mysqli->query('SELECT val FROM prefs WHERE nom = "autorisation_mails"');
    $r['mailenvoi'] = ( $r['autorisation'] > 1 ) ? intval(( $resultat->fetch_row()[0] >> 4*($r['autorisation']-2) & 15 ) > 0) : 0;
    $resultat->free();
    $mysqli->close();
    $r['mail2'] = '';
    $r['etat'] = 'recupok';
    exit(json_encode($r));
  }
  exit('{"etat":"nok","message":"Identifiant non valide"}');

}

///////////////////////////////////////////////
// Récupération des données d'un utilisateur //
///////////////////////////////////////////////
elseif ( ( $action == 'compteglobal' ) && ( $autorisation > 1 ) && $interfaceglobale )  {

  // $_SESSION['compteglobal'] contient l'identifiant du compte à utiliser
  // La deuxième partie de la requête sert de vérification : 
  //  * compte contenant une connexion vers cet utilisateur de ce Cahier
  //  * compte contenant au moins une autre connexion 
  $mysqli = connectsql(false,$interfaceglobale);
  $resultat = $mysqli->query("SELECT connexions FROM comptes 
                              WHERE id = ${_SESSION['compteglobal']} 
                                AND FIND_IN_SET((SELECT id FROM cahiers WHERE rep = TRIM(BOTH '/' FROM '${GLOBALS['chemin']}'))*1000+${_SESSION['id']}, connexions)
                                AND LOCATE(',',connexions)");
  if ( $resultat->num_rows )  {
    $cahiers = implode(',', array_filter(array_map( function($v){return ($v>0)?intdiv($v,1000):false;}, explode(',',$resultat->fetch_row()[0]) )) );
    $resultat->free();
    $resultat = $mysqli->query("SELECT rep, CONCAT(classe,' - ',nom,' (',ville,') ') AS classe
                                FROM cahiers LEFT JOIN lycees ON lycee = lycees.id
                                WHERE FIND_IN_SET(cahiers.id,'$cahiers') ORDER BY FIND_IN_SET(cahiers.id,'$cahiers')");
    $reps = array();
    while ( $r = $resultat->fetch_assoc() ) 
      if ( "/${r['rep']}/" != $chemin )
        $reps[$r['rep']] = $r['classe'];
    $resultat->free();
    exit(json_encode(array('etat'=>'recupok','cahiers'=>$reps)));
  }
  exit('{"etat":"nok","message":"Identifiant non valide"}');
}

///////////////////////////////////////////////////////
// Récupération des données de copies pour un devoir //
///////////////////////////////////////////////////////
elseif ( ( $action == 'transdocs' ) && isset($_REQUEST['id']) && ctype_digit($id = $_REQUEST['id']) )  {

  // Vérification de l'autorisation
  $mysqli = connectsql();
  $resultat = $mysqli->query("SELECT matiere, type & 1 as envoi, type & 2 as aut_colleurs, lien FROM transferts WHERE id = $id AND ( type>>($autorisation-2) & 1 )");
  if ( !$resultat->num_rows )
    exit('{"etat":"nok","message":"Identifiant non valides"}');
  $r = $resultat->fetch_row();
  // Vérification de la matière
  if ( !in_array($mid = $r[0],explode(',',$_SESSION['matieres'])) )  {
    // Cas des profs-colleurs
    if ( ( $autorisation != 5 ) || !in_array("c$mid",explode(',',$_SESSION['matieres'])) || !$r[2] )
      exit('{"etat":"nok","message":"Identifiant non valide"}');
    $autorisation = 3;
  }
  $envoi = $r[1]; // 0 si depuis les élèves, 1 si vers les élèves
  $lien = $r[3];
  
  // Gestion de l'ordre d'affichage
  switch ( $_REQUEST['ordre'] ?? '' )  {
    case 'alphadesc':          $ordre = 'ORDER BY nomcomplet DESC, numero';             break;
    case 'chronoasc':          $ordre = 'ORDER BY upload ASC, nomcomplet ASC, numero';  break;
    case 'chronodesc':         $ordre = 'ORDER BY upload DESC, nomcomplet ASC, numero'; break;
    case 'alphaasc': default:  $ordre = 'ORDER BY nomcomplet ASC, numero';
  }
  // Récupération
  $restriction = ( !$envoi || ( $autorisation == 5 ) ) ? '1' : "( utilisateur = ${_SESSION['id']} )";
  $resultat = $mysqli->query("SELECT doc1.id, doc1.eleve, CONCAT(nom,' ',prenom) AS nomcomplet, date, taille, ext, numero, n, $restriction AS ok
                              FROM ( SELECT id, eleve, utilisateur, numero, upload, DATE_FORMAT(upload,'%e/%m/%Y %kh%i') AS date, ext, taille
                                     FROM transdocs WHERE transfert = $id ) AS doc1
                              LEFT JOIN utilisateurs ON doc1.eleve = utilisateurs.id
                              LEFT JOIN ( SELECT COUNT(*) AS n, eleve FROM transdocs WHERE transfert = $id GROUP BY eleve ) AS doc2
                                        ON doc1.eleve = doc2.eleve
                              $ordre");
  // Génération de la réponse
  $lignes = array();
  if ( $resultat->num_rows )  {
    while ( $r = $resultat->fetch_row() )  {
      // Problème d'encodage des entiers, renvoyés en tant que chaîne.
      // Semble dépendre du driver MySQL, ne prenons pas de risque
      // Pas d'affichage du numéro s'il n'y a qu'un document pour unélève
      // Pas d'affichage détaillé si l'utilisateur est colleur ou lycée
      if ( $r[7] > 1 )
        $r[2] .= "&nbsp;(${r[6]}/${r[7]})";
      $r[0] = intval($r[0]);
      $r[1] = intval($r[1]);
      $r[6] = sha1("${r[0]}-${r[1]}-$lien-$mdp");
      // Enregistrement
      $lignes[] = ( $r[8] ) ? array_slice($r,0,7) : array_slice($r,0,3);
    }
    $resultat->free();
  }
  exit(json_encode(array('etat' => 'recupok', 'verif' => sha1("$id-${_SESSION['id']}-$lien-$mdp"), 'lignes' => $lignes)));
}

/////////////////////////////////////////////
// Récupération des commentaires de colles //
/////////////////////////////////////////////
elseif ( ( $action == 'commentairescolles' ) && isset($_REQUEST['id']) && ctype_digit($id = $_REQUEST['id']) )  {

  // Récupération des données de l'heure demandée
  $mysqli = connectsql();
  $resultat = $mysqli->query("SELECT eleve, note, commentaire, matiere, colleur FROM notescolles WHERE heure = $id");
  $mysqli->close();
  
  if ( $resultat->num_rows )  {
    $matieres = explode(',',$_SESSION['matieres']);
    $nok = true;
    $notes = $comms = array();
    while ( $r = $resultat->fetch_assoc() )  {
      
      // Vérification des droits d'accès : tout colleur pour le prof de la
      // matière, seulement soi-même pour un colleur
      // Vérification au premier passage uniquement
      if ( $nok )  {
        $nok = !( ( $autorisation == 5 ) && in_array($r['matiere'],$matieres) || ( ( $autorisation == 3 ) && in_array($r['matiere'],$matieres) || ( $autorisation == 5 ) && in_array("c${r['matiere']}",$matieres) ) && ( $r['colleur'] == $_SESSION['id'] ) );
        if ( $nok )  {
          $resultat->free();
          exit('{"etat":"nok","message":"Identifiant non valide"}');
        }
      }

      // Encodage du commentaire en base 64 pour éviter les problèmes de parsing en js.
      $eleve = intval($r['eleve']);
      $notes[$eleve] = $r['note'];
      if ( $r['commentaire'] )
        $comms[$eleve] = base64_encode(rawurlencode($r['commentaire']));
    }
    $resultat->free();
    exit(json_encode(array('etat' => 'recupok', 'notes' => $notes, 'comms' => $comms)));
  }
  exit('{"etat":"nok","message":"Identifiant non valide"}');
}

///////////////////////////////////////////////////////////////////////////////////
// Récupération de la liste des profs que l'on peut ajouter en tant que colleurs //
///////////////////////////////////////////////////////////////////////////////////
elseif ( ( $action == 'listeprofs' ) && $_SESSION['admin'] && connexionlight() )  {
  
  $mysqli = connectsql();
  $resultat = $mysqli->query('SELECT id, IF(LENGTH(nom),CONCAT(nom,\' \',prenom),login) AS nomcomplet, matieres FROM utilisateurs WHERE autorisation%10 = 5 AND NOT LOCATE(\'c\',matieres) ORDER BY nomcomplet');
  $mysqli->close();
  if ( $resultat->num_rows )  {
    $noms = $matieres = array();
    while ( $r = $resultat->fetch_row() )  {
      $ids[] = $r[0];
      $noms[] = $r[1];
      $matieres[] = $r[2];
    }
    $resultat->free();
    exit(json_encode(array('etat' => 'recupok', 'ids' => $ids, 'noms' => $noms, 'matieres' => $matieres)));
  }
  else 
    exit('{"etat":"recupok"}');
}

// Réponse par défaut
exit( $message ?: '{"etat":"nok","message":"Accès interdit"}' );
?>
