<?php
// Sécurité
define('OK',1);
// Configuration
include('config.php');
// Fonctions
include('fonctions.php');

//////////////////////////////////////////////
// Commentaires : protection des transferts //
//////////////////////////////////////////////
/* L'activation de la fonction est stockée pour chaque matière dans la table
 * matière (colonne transferts) et pour les transferts généraux dans la table
 * prefs (nom=transferts_general).  
 * Les valeurs de protection globales sont stockées aux mêmes endroits
 * (colonne transferts_protection et nom=transferts_general_protection).
 * Les valeurs de protection globales sont mises à jour à chaque ajout/suppr
 * d'un transfert, comme le dénominateur commun des transferts existants.
 * Les profs éventuellement associés à la matière et les élèves ont toujours
 * accès, les invités jamais. 
 * Code : sens * 1 + autorisation_colleurs * 2 + autorisation_lycée * 4
 *                 + autorisation_profs_non_associés * 8
 * Sens : 0 si depuis les élèves, 1 si vers les élèves
 * Autorisations : 0 si non, 1 si oui
 * Pour les transferts généraux, valeur max 7. Avec matière, 15.
 */

// Mode lecture
$admin = $autorisation && $_SESSION['admin'];
$mode_lecture = 0;
$icones = '';
// Mise en place des icônes générales
// Valable pour les deux premières parties (descriptif matières ou erreurs)
// et transferts-eleves.php en mode lecture
if ( ( $autorisation == 5 ) || $admin )  {
  $donnees = array('action'=>'transferts','matiere'=>0,'protection'=>0,'edition'=>0);
  $mode_lecture = $_SESSION['mode_lecture'];
  $icones = "\n  <div id=\"icones\">\n    <a class=\"icon-lecture".($mode_lecture ? ' mev' : '')."\" title=\"Modifier le mode de lecture\"></a>\n  </div>\n";
  $editionjs = true;
}

// Script contenant la fonction genere_recherche($mysqli,$autorisation,$cle)
// qui retourne une partie de la requête de sélection, et qui lance un 
// téléchargement si demandé (dans ce cas, le script contient exit).
$mysqli = connectsql();
include('transferts-fonctions.php');

// Table étendue des matières
$resultat = $mysqli->query('SELECT GROUP_CONCAT(val) FROM prefs WHERE nom LIKE "transferts%" ORDER BY nom');
list($transferts,$protection) = explode(',',$resultat->fetch_row()[0]);
$resultat->free();
$tablematieres = ( $transferts < 2 ) ? "( ( SELECT id, ordre, cle, nom, transferts, transferts_protection FROM matieres) UNION (SELECT  0, 0, 'general', 'Général', $transferts, $protection ) ) AS m" : 'matieres AS m';

//////////////////
// Autorisation //
//////////////////

// Accès aux professeurs, lycée, colleurs, élèves connectés uniquement
if ( !$autorisation )  {
  $titre = 'Transferts de documents personnels';
  $actuel = false;
  include('login.php');
}

// Affichage différent pour les élèves
// transferts-eleves.php contient fin()
if ( $autorisation == 2 )
  include('transferts-eleves.php');
// Accès interdit pour les comptes invités
if ( $autorisation == 1 )  {
  debut($mysqli,'Transferts de documents personnels','Vous n\'avez pas accès à cette page.',$autorisation,' ');
  $mysqli->close();
  fin();
}

/////////////////////////////////////////////////
// Pas de matière demandée : affichage spécial //
/////////////////////////////////////////////////
// Affichage de la liste des matières si plusieurs
// possibles, des transferts de la matière si une seule
// Ici, on est forcément colleur, lycée, prof, admin ou en mode lecture
if ( empty($_GET) )  {
  if ( ( $autorisation == 5 ) && !$mode_lecture )  {
    $requete = 'transferts < 2';
    // Cas des profs étant colleurs dans d'autres matières
    if ( strpos($_SESSION['matieres'],'c') )  {
      $m = str_replace('c','',implode(',',array_filter(explode(',',$_SESSION['matieres']),function($v){return $v[0]=='c';})));
      $requete = "transferts < 2 AND FIND_IN_SET(m.id,'${_SESSION['matieres']}') OR transferts = 1 AND (32-transferts_protection) & 4 AND type & 2 AND FIND_IN_SET(m.id,'$m')";
    }
  }
  else  {
    $a = ( $mode_lecture ) ? $mode_lecture-2 : $autorisation-1;
    $requete = "transferts = 1 AND (32-transferts_protection)>>$a & 1 AND type>>($a-1) & 1 AND FIND_IN_SET(m.id,'${_SESSION['matieres']}')";
  }
  $resultat = $mysqli->query("SELECT m.id, cle, nom, transferts, transferts_protection AS protection, COUNT(t.id) AS n
                              FROM $tablematieres LEFT JOIN transferts AS t ON m.id = t.matiere
                              WHERE $requete GROUP BY m.id ORDER BY ordre");
  if ( $n = $resultat->num_rows )  {
    // Si une seule matière trouvée, réglage automatique sur cette matière
    if ( $n == 1 )  {
      $matiere = $resultat->fetch_assoc();
      $resultat->free();
    }
    // Si plusieurs matières trouvées, choix à faire.
    else  {
      // transferts-eleves.php contient fin()
      if ( $mode_lecture == 3 )
        include('transferts-eleves.php');
      debut($mysqli,'Transferts de documents personnels',$message,$autorisation,'transferts',$donnees ?? false);
      $mysqli->close();
      echo "$icones\n  <article>\n    <h2>Mes matières</h2>";
      $pasdetransfert = 0;
      while ( $r = $resultat->fetch_assoc() )  {
        if ( $r['transferts'] )  {
          if ( $mode_lecture )
            echo "\n    <h3 class=\"detailmatiere\"><a href=\"transferts?${r['cle']}\">${r['nom']}</a></h3>";
          else  {
            $detail = ( $r['n'] == 1 ) ? '(Un seul transfert déjà existant)' : "(${r['n']} transferts déjà existants)";
            echo "\n    <h3 class=\"detailmatiere\"><a href=\"transferts?${r['cle']}\">${r['nom']}</a><span>$detail</span></h3>";
          }
        }
        // Visible uniquement par les profs
        elseif ( ( $autorisation == 5 ) && in_array($r['id'],explode(',',$_SESSION['matieres'])) )  {
          echo "\n    <h3 class=\"detailmatiere\"><a href=\"transferts?${r['cle']}\">${r['nom']}</a><span>(Aucun transfert pour l'instant)</span></h3>";
          $pasdetransfert += 1;
        }
      }
      if ( ( $autorisation == 5 ) && $pasdetransfert )
        echo "\n    <p>".( ( $pasdetransfert == 1 ) ? 'Une matière ne contient' : "$pasdetransfert matières ne contiennent" ).' pas encore de transfert de documents. Vous pouvez désactiver la fonction «&nbsp;transferts de documents&nbsp;» pour les matières où vous ne comptez pas l\'utiliser dans les <a href="matieres">réglages de vos matières</a>. Si une seule matière est en réalité concernée, elle sera automatiquement affichée ici.</p>';
      echo "\n  </article>\n";
      $resultat->free();
      fin($editionjs ?? false);
    }
  }
  // Pas de matière concernée !
  else  {
    debut($mysqli,'Transferts de documents personnels','Cette page ne contient aucune information.',$autorisation,' ',$donnees ?? false);
    $mysqli->close();
    echo $icones;
    fin($editionjs ?? false);
  }
}

////////////////////////////////////////
// Validation de la requête : matière //
////////////////////////////////////////

// Recherche de la matière concernée, variable $matiere
// Si le compte n'est associé qu'à une matière, on la choisit automatiquement.
// Sinon, on cherche $_REQUEST['cle'] dans les matières disponibles.
// transferts=0 : pas de transfert saisi
// transferts=1 : déjà des transferts saisis
// transferts=2 : fonction désactivée, pas d'affichage
if ( !isset($matiere) )  {
  $resultat = $mysqli->query("SELECT id, cle, nom, transferts_protection AS protection FROM $tablematieres 
                              WHERE transferts < 2" . ( $autorisation == 5 ? '' : " AND FIND_IN_SET(id,'${_SESSION['matieres']})')" ) );
  if ( $resultat->num_rows == 1 )  {
    $matiere = $resultat->fetch_assoc();
    $resultat->free();
  }
  elseif ( $resultat->num_rows )  {
    if ( !empty($_REQUEST) )  {
      while ( $r = $resultat->fetch_assoc() )
        if ( isset($_REQUEST[$r['cle']]) )  {
          $matiere = $r;
          break;
        }
    }
    $resultat->free();
    // Si aucune matière trouvée
    if ( !isset($matiere) )  {
      debut($mysqli,'Transferts de documents personnels','Mauvais paramètre d\'accès à cette page.',$autorisation,' ',$donnees ?? false);
      $mysqli->close();
      echo $icones;
      fin($editionjs ?? false);
    }
  }
  // Si aucune matière avec des transferts n'est enregistrée
  else  {
    debut($mysqli,'Transferts de documents personnels','Cette page ne contient aucune information.',$autorisation,' ',$donnees ?? false);
    $mysqli->close();
    echo $icones;
    fin($editionjs ?? false);
  }
}
$mid = $matiere['id'];
$cle = $matiere['cle'];

////////////
/// HTML ///
////////////
// Données globales par défaut
// MathJax désactivé par défaut
$mathjax = false;
$icones = '';
// Pour les profs : modifications dont dates des transferts
// Pour les autres : modifications (seulement si transfert autorisé)
// L'accès ici est impossible si on est non connecté, invité ou élève. 
$donnees = array('action'=>'transferts','matiere'=>$mid);
if ( $edition = acces($matiere['protection'],$mid,"Transferts de documents personnels - ${matiere['nom']}","transferts?$cle",$mysqli) )  {
  $donnees['css'] = 'datetimepicker';
  $icones = "\n    <a class=\"icon-ajoute formulaire\" title=\"Ajouter un transfert\"></a>\n    <a class=\"icon-lecture\" title=\"Modifier le mode de lecture\"></a>";
}
if ( $mode_lecture )  {
  // Accès non autorisé : on ne peut être en mode lecture que si on est 
  // propriétaire de la page ou administrateur
  if ( ( $edition != 2 ) && !$admin )  {
    debut($mysqli,$titre,'Vous n\'avez pas accès à cette page.',5,' ');
    $mysqli->close();
    fin();
  }
  // Mode lecture pour les élèves
  $donnees['protection'] = $donnees['edition'] = 0;
  $icones = '<a class="icon-lecture mev" title="Modifier le mode de lecture"></a>';
  // transferts-eleves.php contient fin()
  if ( $mode_lecture == 3 )
    include('transferts-eleves.php');
  // Mode lecture pour les utilisateurs interdits
  elseif ( ( $mode_lecture < 3 ) || !( (32-$matiere['protection']) >> ($mode_lecture-2) & 1 ) )  {
    debut($mysqli,'Transferts de documents personnels',$message,$autorisation,"transferts?$cle",$donnees);
    $mysqli->close();
    echo "  <div id=\"icones\">$icones</div>\n  <article><h2>Cette page n'est pas autorisée pour ce type d'utilisateur.</h2></article>\n\n";
    fin(true);
  }
  // On supprime les icônes d'édition sur chaque transfert
  $edition = false;
  $autorisation = $mode_lecture - 1;
}
debut($mysqli,"Transferts de documents personnels - ${matiere['nom']}",$message,$autorisation,"transferts?$cle",$donnees);

// Icônes générales
echo <<< FIN

  <div id="icones" data-action="page">$icones
    <a class="icon-aide" title="Aide pour les transfers de documents personnels"></a>
  </div>

FIN;

// Barre de recherche
$requete = genere_recherche($mysqli,$autorisation,$cle);

// Récupération de l'ensemble des transferts
$requete_autorisation = ( $edition == 2 ) ? '' : "AND ( type>>($autorisation-2) & 1 )";
$resultat = $mysqli->query("SELECT id, type & 1 as envoi, type | 1 as type, titre, prefixe, lien, indications,
                             deadline>NOW() AS encours, DATE_FORMAT(deadline,'%d/%m/%Y %kh%i') AS limite,
                             DATE_FORMAT(deadline,'%w%Y%m%e') AS date_to, DATE_FORMAT(deadline,'%kh%i') AS heure_to,
                             dispo>NOW() AS bientot, IF(dispo,DATE_FORMAT(dispo,'%e/%m/%Y %kh%i'),0) AS dispo,
                             DATE_FORMAT(dispo,'%w%Y%m%e') AS date_from, DATE_FORMAT(dispo,'%kh%i') AS heure_from
                             FROM transferts WHERE matiere = $mid $requete_autorisation ". ( $requete ?: 'ORDER BY GREATEST(deadline,dispo) DESC' ) );
// On force le bit le plus faible à être présent par "type | 1"
$comptes = array('professeurs','colleurs','comptes de type lycée','professeurs (non associés à la matière)');
if ( $n = $resultat->num_rows )  {
  while ( $r = $resultat->fetch_assoc() )  {
    // Pour les profs, icones de modification/suppression et détail des utilisateurs
    if ( $edition )  {
      $type = $r['type'];
      $sens = sprintf( ($r['envoi'] ? 'Transfert des %s vers les élèves' : 'Transfert des élèves vers les %s'), preg_replace('/,([^,]+)$/',' et$1',implode(', ',array_filter($comptes,function($a) use($type) { return $type >> $a & 1; },ARRAY_FILTER_USE_KEY))) );
      $icones = "\n    <a class=\"icon-supprime\" title=\"Supprimer ce transfert\"></a>\n    <a class=\"icon-edite formulaire\" title=\"Modifier ce transfert\"></a>";
    }
    else  {
      $sens = ( $r['envoi'] ? 'Transfert vers les élèves' : 'Transfert depuis les élèves' );
      $icones = '';
    }
    // Dates
    $date_to = format_date($r['date_to']);
    $heure_to = " à ${r['heure_to']}";
    if ( $r['bientot'] )  {
      $classe = ' nodispo';
      $date_from = format_date($r['date_from']);
      $heure_from = ( $r['heure_from'] == '0h00' ? '' : " à ${r['heure_from']}" ); 
      $horaires = ( $r['envoi'] ? "Ce transfert n'est <span class=\"mev\">pas encore visible</span> des élèves, ne le sera qu'<strong>à partir du $date_from$heure_from</strong>. Vous pouvez déjà envoyer des documents et le faire <strong>jusqu'au $date_to$heure_to</strong>"
                                : "Ce transfert n'est <span class=\"mev\">pas encore visible</span> des élèves, ne le sera qu'<strong>à partir du $date_from$heure_from</strong>. Les élèves pourront alors envoyer des documents <strong>jusqu'au $date_to$heure_to</strong>" );
    }
    else  {
      $classe = '';
      $horaires = ( $r['encours'] ? "Ce transfert est <span class=\"mev\">en cours</span>. Les envois de documents sont possibles jusqu'au <strong>$date_to$heure_to</strong>."
                                  : "Ce transfert est <span class=\"mev\">terminé</span> depuis le <strong>$date_to$heure_to</strong>. Les transferts de documents ne sont plus possibles." );
    }
    // Mode réduit s'il y a plus de 5 éléments
    $affreduit = $styleaffcomplet = '';
    if ( $n > 5 )  {
      $styleaffcomplet = 'style="display: none;"';
      $affreduit = "\n<p class=\"affreduit\">Transfert".( $r['envoi'] ? ' vers les élèves' : ' depuis les élèves' ).( $r['encours'] ? ' en cours' : ' terminé le '.substr($date_to,0,-5) ).' <span>voir les détails</span></p>';
    }
    // Indications
    $indications = ( $r['indications'] ? "<p><strong>Indications pour les élèves&nbsp;:</strong></p>\n    <div class=\"indications\">${r['indications']}</div>" : '<p>Il n\'y a pas d\'indication spécifique visible des élèves.</p>' );
    $mathjax = $mathjax ?: boolval(strpos($r['indications'],'$')+strpos($r['indications'],'\\'));
    // Récupération du nombre de participants
    $resultat1 = $mysqli->query("SELECT COUNT(DISTINCT eleve), COUNT(id), COUNT(NULLIF(utilisateur,${_SESSION['id']})) FROM transdocs WHERE transfert = ${r['id']}");
    $s = $resultat1->fetch_row();
    $resultat1->free();
    if ( $s[0] )  {
      $concernes = "Ce transfert concerne <strong>${s[0]} élève".( ( $s[0] > 1 ) ? 's' : '' ).'</strong>';
      $concernes .= ( $s[1] != $s[0] ) ? " (${s[1]} document".( ( $s[1] > 1 ) ? 's' : '' ).' envoyé'.( ( $s[1] > 1 ) ? 's' : '' ).').' : '.';
      $icones .= "\n    <a class=\"icon-voirtout formulaire\" title=\"Voir la liste des documents\"></a>";
    }
    else 
      $concernes = "Aucun document n'a encore été envoyé.";
    // Icône d'envoi/récupération
    if ( $r['envoi'] )  {
      $iconetransfert = ( $r['encours'] ? "\n    <a class=\"icon-ajoutetransdocs formulaire\" title=\"Ajouter des documents\"></a>" : '' );
      if ( $s[0] )
        $concernes .= ( $nperso = $s[1]-$s[2] ) ? " Vous avez envoyé $nperso document".( ( $nperso > 1 ) ? 's' : '' ).'.' : '';
    }
    else
      $iconetransfert = ( $s[0] ? "\n    <a class=\"icon-download\" href=\"?dltransfert=${r['id']}&verif=".sha1("${r['id']}-${_SESSION['id']}-${r['lien']}-$mdp").'" title="Télécharger l\'ensemble des documents"></a>' : '' );
    // Affichage du transfert 
    echo <<< FIN

  <article class="transfert$classe" data-id="${r['id']}" data-prefixe="${r['prefixe']}" data-deadline="${r['limite']}" data-dispo="${r['dispo']}">
    <a class="icon-aide" title="Aide pour l'édition de ce transfert"></a>$icones$iconetransfert
    <h3>${r['titre']}</h3>$affreduit
    <div class="affcomplet" $styleaffcomplet>
      <p><strong>$sens</strong></p>
      <p>$horaires</p>
      <p>$concernes</p>
      $indications
    </div>
  </article>

FIN;
  }
  $resultat->free();
}
// Pas de transfert
else  {
  if ( $requete )  
    echo "\n  <article>\n    <h3>Aucun transfert de documents ".( $mid ? "en ${matiere['nom']}" : 'sans matière associée')." ne correspond à cette recherche.</h3>\n    <p class=\"center\"><a href=\"?$cle\">Annuler la recherche</a>.</p>\n  </article>\n";
  elseif ( $autorisation == 5 )
    echo "\n  <article>\n    <h3>Vous n'avez encore organisé aucun transfert de documents ".( $mid ? "en ${matiere['nom']}" : 'sans matière associée')." cette année.</h3>\n    <p>Pour en créer un, cliquez sur l'icône <span class=\"icon-ajoute\"></span> en haut de cette page.</p>\n  </article>\n";
  else
    echo "\n  <article>\n    <h3>Aucun transfert de documents ".( $mid ? "en ${matiere['nom']}" : 'sans matière associée')." n'a encore été organisé cette année.</h3>\n    <p>Seuls les professeurs ".( $mid ? 'associés à la matière' : '')." peuvent en créer.</p>\n  </article>\n";
}

// Récupération de la liste des élèves pour la construction du tableau d'envoi de corrections en javascript
$resultat = $mysqli->query("SELECT id, CONCAT(nom,',',prenom) AS eleve FROM utilisateurs WHERE autorisation = 2 AND mdp > '0' AND FIND_IN_SET($mid,matieres) ORDER BY IF(LENGTH(nom),nom,login)");
$eids = array();
$enoms = array();
if ( $resultat->num_rows )  {
  while ( $r = $resultat->fetch_row() )  {
    $eids[] = intval($r[0]);
    $enoms[] = $r[1];
  }
  $resultat->free();
}  
$mysqli->close();

// Taille maximale de fichier (pour l'aide)
$taille = min(ini_get('upload_max_filesize'),ini_get('post_max_size'));
if ( stristr($taille,'m') )
  $taille = substr($taille,0,-1)*1048576;
elseif ( stristr($taille,'k') )
  $taille = substr($taille,0,-1)*1024;
$taille = ( $taille < 1048576 ) ? intval($taille/1024).'&nbsp;ko' : intval($taille/1048576).'&nbsp;Mo';

// Aide et formulaire d'ajout
?>

  <script type="text/javascript">
    eids = <?php echo json_encode($eids); ?>;
    enoms = <?php echo json_encode($enoms); ?>;
  </script>

  <form id="form-edite">
    <h3 class="edition">Modifier un transfert</h3>
    <p class="ligne"><label for="titre">Titre&nbsp;: </label><input type="text" name="titre" value="" size="100"></p>
    <p class="ligne"><label for="prefixe">Préfixe&nbsp;: </label><input type="text" name="prefixe" value="" size="15"></p>
    <p class="ligne"><label for="deadline">Date limite d'envoi&nbsp;: </label><input type="text" name="deadline" value="" size="15"></p>
    <p class="ligne"><label for="dispo">Disponibilité &nbsp;: </label><input type="text" name="dispo" value="" size="15"></p>
    <p class="ligne"><label for="indications">Indications visibles pour les élèves&nbsp;: </label></p>
    <textarea name="indications" class="edithtml" rows="10" cols="100" placeholder="Indications visibles pour les élèves, lien vers le document que vous mettez en ligne..."></textarea>
  </form>
  
  <form id="form-ajoute" data-action="ajout-transfert">
    <h3 class="edition">Ajouter un transfert</h3>
    <p class="ligne"><label for="titre">Titre&nbsp;: </label><input type="text" name="titre" value="" size="100" placeholder="Titre du transfert"></p>
    <p class="ligne"><label for="prefixe">Préfixe&nbsp;: </label><input type="text" name="prefixe" value="" size="15" placeholder="Nom court, préfixe des noms de fichiers récupérés"></p>
    <p class="ligne"><label for="sens">Sens&nbsp;: </label><select name="sens"><option value="0">Envoi des élèves</option><option value="1">Envoi vers les élèves</option></select></p>
    <p class="ligne"><label for="accestransfert">Encadrants concernés&nbsp;: </label><select name="accestransfert[]" multiple></select></p>
    <p class="ligne"><label for="deadline">Date limite d'envoi&nbsp;: </label><input type="text" name="deadline" value="" size="15"></p>
    <p class="ligne"><label for="dispo">Disponibilité &nbsp;: </label><input type="text" name="dispo" value="" size="15"></p>
    <p class="ligne"><label for="indications">Indications visibles pour les élèves&nbsp;: </label></p>
    <textarea name="indications" class="edithtml" rows="10" cols="100" placeholder="Indications visibles pour les élèves, lien vers le document que vous mettez en ligne..."></textarea>
  </form>
  
  <form id="form-voirtout" data-action="voir-transdocs">
    <p class="icones">
      <a class="icon-chronodesc" title="Classer par ordre chronologique inversé"></a>
      <a class="icon-chronoasc" title="Classer par ordre chronologique"></a>
      <a class="icon-alphadesc" title="Classer par ordre alphabétique inversé"></a>
      <a class="icon-alphaasc actuel" title="Classer par ordre alphabétique"></a>
      <a class="icon-actualise" title="Actualiser"></a>
    </p>
    <h3 class="edition">Détail d'un transfert</h3>
    <table>
      <tbody>
        <tr>
          <th>Élève</th><th>Date</th><th>Taille</th><th>Type</th>
          <th class="icones">
            <a class="icon-download" title="Télécharger l'ensemble des documents cochés"></a>
            <a class="icon-supprime" title="Supprimer l'ensemble des documents cochés"></a>
          </th>
          <th class="icones"><a class="icon-cocher" title="Tout cocher"></a></th>
        </tr>
      </tbody>
    </table>
  </form>

  <form id="form-ajoutetransdocs" data-action="ajout-transdocs">
    <h3 class="edition">Ajouter des documents</h3>
    <p class="ligne"><label for="fichier[]">Fichiers&nbsp;: </label><input type="file" name="fichier[]" multiple></p>
    <h3>Documents déjà envoyés</h3>
    <table>
      <tbody>
        <tr>
          <th>Élève</th><th>Date</th><th>Taille</th><th>Type</th>
        </tr>
      </tbody>
    </table>
  </form>

  <div id="aide-page">
    <h3>Aide et explications</h3>
    <p>Il est possible ici d'ajouter et de modifier un transfert de documents personnels entre les élèves et les encadrants, c'est-à-dire les colleurs/comptes lycée/professeurs. Il est possible aussi de visualiser les documents envoyés, et d'en ajouter de nouveaux.</p>
    <p>La différence entre cette fonction et la fonction <em>Documents à télécharger</em> réside dans la visibilité des documents envoyés. Chaque transfert a deux propriétés d'utilisation : le sens (élèves vers encadrants ou encadrants vers élèves) et les encadrants concernés (professeurs obligatoirement, colleurs ou comptes de type lycée éventuellement). Chaque document envoyé est associé à un seul élève et n'est visible que par cet élève et l'ensemble des encadrants autorisés.</p>
    <p>Les documents transférés ne sont jamais visibles sans identification. Ils ne sont pas visibles par les moteurs de recherche.</p>
    <p>Un transfert peut être lié à une matière ou non. Les transferts non liés à une matière sont accessibles en passant obligatoirement par le lien <span class="icon-transfert"></span> du menu.</p>
    <p>La taille des documents envoyés simultanément est limitée à <?php echo $taille; ?>. Il n'y a pas de limite dans le sens inverse.</p>
    <h4>Actions générales</h4>
    <p>Les boutons généraux permettent de&nbsp;:</p>
    <ul>
      <li><span class="icon-chronodesc"></span>,<span class="icon-chronoasc"></span>,<span class="icon-alphadesc"></span>,<span class="icon-alphaasc"></span>&nbsp;: changer l'ordre de visualisation en classant soit selon le titre des transferts, soit suivant l'ordre chronologique de la date limite.</li>
      <li><span class="icon-ajoute"></span>&nbsp;: ajouter un transfert de documents personnels (professeurs seulement).</li>
    </ul>
    <h4>Possibilités de téléchargement</h4>
    <p>Les professeurs (éventuellement associés à la matière à laquelle le transfert est lié) sont les seuls à pouvoir créer et modifier des transferts. Ils peuvent donner accès aux colleurs et aux comptes de type lycée.</p>
    <p>Quel que soit le sens du transfert, les professeurs ont la possibilité de télécharger tous les documents. Quel que soit le sens du transfert, les élèves ne peuvent télécharger que les documents qui les concernent explicitement. Un document ne peut pas concerner deux élèves ou plus.</p>
    <p>Si le transfert est dans le sens élèves vers encadrants, l'ensemble des encadrants autorisés peuvent télécharger tous les documents envoyés par les élèves. Les documents ne sont pas fléchés vers un encadrant spécifique.</p>
    <p>Si le transfert est dans le sens encadrants vers élèves, chaque encadrant ne peut télécharger que les documents qu'il a envoyés.</p>
    <p>Les documents téléchargés sont éventuellement regroupés dans un fichier <code>zip</code>. Ils sont systématiquement renommés pour faire apparaître le nom du transfert et le nom de l'élève. Si, dans un même transfert, plusieurs documents correspondent à un seul élève, ils sont de plus numérotés.</p>
    <h4>Date de disponibilité et date limite d'envoi</h4>
    <p>Deux dates-heures sont définies pour chaque transfert&nbsp;:</p>
    <ul>
      <li>une <em>date de disponibilité</em> qui correspond à la date-heure à laquelle le transfert sera visible pour les élèves. Avant cette date-là, il est invisible pour eux. Mais pour tous les encadrants autorisés, le transfert n'est jamais invisible.</li>
      <li>une <em>date limite d'envoi</em> qui correspond à la date-heure jusqu'à laquelle les élèves ou les encadrants peuvent envoyer des documents, selon le sens du transfert. Une fois cette date dépassée, plus aucun nouveau document ne peut être envoyé, mais le transfert continue d'apparaître et les documents continuent d'être téléchargeables par les élèves et les encadrants concernés.</li>
    </ul>
    <p>La date de disponibilité peut rester vide ou doit obligatoirement être située dans le futur à la création du transfert. La date limite d'envoi est nécessairement ultérieure à la date de disponibilité.</p>
    <p>Les transferts de documents personnels en affichage différé sont indiqués par un fond plus clair.</p>
    <h4>Actions spécifiques à chaque transfert</h4>
    <p>Pour chaque transfert, des boutons sont disponibles afin de&nbsp;:</p>
    <ul>
      <li><span class="icon-download"></span>&nbsp;: dans le cas d'un transfert élèves vers encadrants uniquement, télécharger immédiatement l'ensemble des documents arrivés à l'instant. Ils sont regroupés dans un fichier <code>zip</code> dont le nom est horodaté. Il vaut peut-être mieux attendre la fin de la date limite d'envoi...</li>
      <li><span class="icon-ajoutetransdocs"></span>&nbsp;: dans le cas d'un transfert encadrants vers élèves uniquement et avant la date limite d'envoi, ouvrir un formulaire permettant d'envoyer de nouveaux documents. Ce bouton n'est plus accessible après la date limite d'envoi.</li>
      <li><span class="icon-voirtout"></span>&nbsp;: ouvrir un formulaire permettant de voir la liste des documents accessibles, de les télécharger et éventuellement de les supprimer</li>
<?php if ( $edition )  { ?>
      <li><span class="icon-edite"></span>&nbsp;: éditer les propriétés du transfert</li>
      <li><span class="icon-supprime"></span>&nbsp;: supprimer le transfert et tous les documents correspondants (une confirmation sera demandée)</li>
<?php } ?>
    </ul>
    <h4>Affectation des documents aux élèves</h4>
    <p>Pour les transferts dans le sens encadrants vers élèves, les documents sont automatiquement affectés aux élèves à l'aide des noms des documents. Le site, avant l'envoi des documents, analyse les noms des documents et y cherche les noms des élèves. Une proposition d'affectation de chaque document à un élève est faite, et modifiable avant envoi.</p>
    <p>Une affectation de document à un élève n'est pas modifiable après envoi.</p>
    <h4>Annonce des transferts et des documents envoyés</h4>
    <p>Aucune annonce automatique n'est faite aux élèves lorsqu'un transfert est rendu disponible, ni quand un document est envoyé dans un sens ou dans l'autre. Il est donc préférable de prévenir les élèves, par exemple par mail, lorsque des documents personnels importants leur sont envoyés.</p>
    <h4>Lire aussi...</h4>
    <p>Une autre <span class="icon-aide"></span>&nbsp;aide dans le cadre de chaque transfert donne d'autres précisions sur les différents boutons modifiant chaque information. Une autre aide est aussi disponible dans chaque action. N'hésitez pas à les consulter&nbsp;!</p>
  </div>

  <div id="aide-transferts">
    <h3>Aide et explications</h3>
    <p>La différence entre cette fonction et la fonction <em>Documents à télécharger</em> réside dans la visibilité des documents envoyés. Chaque transfert a deux propriétés d'utilisation : le sens (élèves vers encadrants ou encadrants vers élèves) et les encadrants concernés (professeurs obligatoirement, colleurs ou comptes de type lycée éventuellement). Chaque document envoyé est associé à un seul élève et n'est visible que par cet élève et l'ensemble des encadrants autorisés.</p>
    <p>Les documents transférés ne sont jamais visibles sans identification. Ils ne sont pas visibles par les moteurs de recherche.</p>
    <h4>Actions spécifiques à chaque transfert</h4>
    <p>Pour chaque transfert, des boutons sont disponibles afin de&nbsp;:</p>
    <ul>
      <li><span class="icon-download"></span>&nbsp;: dans le cas d'un transfert élèves vers encadrants uniquement, télécharger immédiatement l'ensemble des documents arrivés à l'instant. Ils sont regroupés dans un fichier <code>zip</code> dont le nom est horodaté. Un nouveau <code>zip</code> est régénéré à chaque téléchargement, ce qui peut surcharger le serveur et prendre un peu de temps. Merci de l'utiliser avec parcimonie...</li>
      <li><span class="icon-ajoutetransdocs"></span>&nbsp;: dans le cas d'un transfert encadrants vers élèves uniquement et avant la date limite d'envoi, ouvrir un formulaire permettant d'envoyer de nouveaux documents. Ce bouton n'est plus accessible après la date limite d'envoi.</li>
      <li><span class="icon-voirtout"></span>&nbsp;: ouvrir un formulaire permettant de voir la liste des documents accessibles, de les télécharger et éventuellement de les supprimer</li>
<?php if ( $edition )  { ?>
      <li><span class="icon-edite"></span>&nbsp;: éditer les propriétés du transfert</li>
      <li><span class="icon-supprime"></span>&nbsp;: supprimer le transfert et tous les documents correspondants (une confirmation sera demandée)</li>
<?php } ?>
    </ul>
    <h4>Possibilités de téléchargement</h4>
    <p>Les professeurs (éventuellement associés à la matière à laquelle le transfert est lié) sont les seuls à pouvoir créer et modifier des transferts. Ils peuvent donner accès aux colleurs et aux comptes de type lycée.</p>
    <p>Quel que soit le sens du transfert, les professeurs ont la possibilité de télécharger tous les documents. Quel que soit le sens du transfert, les élèves ne peuvent télécharger que les documents qui les concernent explicitement. Un document ne peut pas concerner deux élèves ou plus.</p>
    <p>Si le transfert est dans le sens élèves vers encadrants, l'ensemble des encadrants autorisés peuvent télécharger tous les documents envoyés par les élèves. Les documents ne sont pas fléchés vers un encadrant spécifique.</p>
    <p>Si le transfert est dans le sens encadrants vers élèves, chaque encadrant ne peut télécharger que les documents qu'il a envoyés.</p>
    <p>Les documents téléchargés sont éventuellement regroupés dans un fichier <code>zip</code>. Ils sont systématiquement renommés pour faire apparaître le nom du transfert et le nom de l'élève. Si, dans un même transfert, plusieurs documents correspondent à un seul élève, ils sont de plus numérotés.</p>
    <h4>Date de disponibilité et date limite d'envoi</h4>
    <p>Deux dates-heures sont définies pour chaque transfert&nbsp;:</p>
    <ul>
      <li>une <em>date de disponibilité</em> qui correspond à la date-heure à laquelle le transfert sera visible pour les élèves. Avant cette date-là, il est invisible pour eux. Mais pour tous les encadrants autorisés, le transfert n'est jamais invisible.</li>
      <li>une <em>date limite d'envoi</em> qui correspond à la date-heure jusqu'à laquelle les élèves ou les encadrants peuvent envoyer des documents, selon le sens du transfert. Une fois cette date dépassée, plus aucun nouveau document ne peut être envoyé, mais le transfert continue d'apparaître et les documents continuent d'être téléchargeables par les élèves et les encadrants concernés.</li>
    </ul>
    <p>La date limite d'envoi est nécessairement ultérieure à la date de disponibilité.</p>
    <p>Les transferts de documents personnels en affichage différé sont indiqués par un fond plus clair.</p>
    <h4>Affectation des documents aux élèves</h4>
    <p>Pour les transferts dans le sens encadrants vers élèves, les documents sont automatiquement affectés aux élèves à l'aide des noms des documents. Le site, avant l'envoi des documents, analyse les noms des documents et y cherche les noms des élèves. Une proposition d'affectation de chaque document à un élève est faite, et modifiable avant envoi.</p>
    <p>Une affectation de document à un élève n'est pas modifiable après envoi.</p>
    <h4>Annonce des transferts et des documents envoyés</h4>
    <p>Aucune annonce automatique n'est faite aux élèves lorsqu'un transfert est rendu disponible, ni quand un document est envoyé dans un sens ou dans l'autre. Il est donc préférable de prévenir les élèves, par exemple par mail, lorsque des documents personnels importants leur sont envoyés.</p>
  </div>

  <div id="aide-edite">
    <h3>Aide et explications</h3>
    <p>Ce formulaire permet de modifier un transfert existant. Il sera validé par un clic sur <span class="icon-ok"></span>, et abandonné (donc supprimé) par un clic sur <span class="icon-ferme"></span>.</p>
    <p>Le <em>titre</em> est le titre du transfert affiché dans le cadre correspondant sur cette page. Il est de même affiché pour les élèves. Il doit être assez simple mais il vaut mieux qu'il soit différent à chaque transfert. Par exemple, «&nbsp;Devoir Maison n°9&nbsp;» ou «&nbsp;Compte-rendu de colle, semaine 12&nbsp;». Ce n'est pas la peine d'y indiquer la matière éventuelle puisqu'elle est mentionnée sur cette page.</p>
    <p>Le <em>préfixe</em> est un nom court qui servira de préfixe aux fichiers récupérés, qui seront automatiquement renommés sous la forme <code>prefixe&nbsp;-&nbsp;nom&nbsp;prénom</code>. Il vaut mieux mettre un nom court, les espaces sont autorisés. Par exemple, «&nbsp;DM9&nbsp;» ou «&nbsp;CR colle&nbsp;12&nbsp;».</p>
    <p>La <em>date limite d'envoi</em> correspond à la date-heure jusqu'à laquelle les élèves ou les encadrants peuvent envoyer des documents, selon le sens du transfert. Une fois cette date dépassée, plus aucun nouveau document ne peut être envoyé, mais le transfert continue d'apparaître et les documents continuent d'être téléchargeables par les élèves et les encadrants concernés.</p>
    <p>La <em>date de disponibilité</em> correspond à la date-heure à laquelle le transfert sera visible pour les élèves. Avant cette date-là, il est invisible pour eux. Mais pour tous les encadrants autorisés, le transfert n'est jamais invisible. </p>
    <p>Valider une <em>disponibilité</em> vide annule l'affichage différé&nbsp;: le transfert est visible par les élèves immédiatement.</p>
    <p>La date limite d'envoi est nécessairement ultérieure à la date de disponibilité.</p>
    <p>Les <em>indications visibles pour les élèves</em> sont les indications que vous pouvez donner à vos élèves. Grâce aux boutons d'édition, vous pouvez formatter ce texte et ajouter des liens vers les autres pages du site, vers des documents du site, vers d'autres pages sur le web... L'insertion de ressources de type image, pdf ou vidéo, est aussi possible. Par exemple, vous pouvez positionner un sujet dans les <em>Documents à télécharger</em>, avec affichage différé, et mettre le lien ici.</p>
    <p>Les <em>indications</em> ne sont pas obligatoires.</p>
    <p>Le sens du transfert n'est pas modifiable après sa création.</p>
  </div>

  <div id="aide-ajoute">
    <h3>Aide et explications</h3>
    <p>Ce formulaire permet de créer un nouveau transfert de documents personnels. Il sera validé par un clic sur <span class="icon-ok"></span>, et abandonné (donc supprimé) par un clic sur <span class="icon-ferme"></span>.</p>
    <p>La différence entre cette fonction et la fonction <em>Documents à télécharger</em> réside dans la visibilité des documents envoyés. Chaque transfert a deux propriétés d'utilisation : le sens (élèves vers encadrants ou encadrants vers élèves) et les encadrants concernés (professeurs obligatoirement, colleurs ou comptes de type lycée éventuellement). Chaque document envoyé est associé à un seul élève et n'est visible que par cet élève et l'ensemble des encadrants autorisés.</p>
    <p>Les documents transférés ne sont jamais visibles sans identification. Ils ne sont pas visibles par les moteurs de recherche.</p>
    <h4>Champs à remplir</h4>
    <p>Le <em>titre</em> est le titre du transfert affiché dans le cadre correspondant sur cette page. Il est de même affiché pour les élèves. Il doit être assez simple mais il vaut mieux qu'il soit différent à chaque transfert. Par exemple, «&nbsp;Devoir Maison n°9&nbsp;» ou «&nbsp;Compte-rendu de colle, semaine 12&nbsp;». Ce n'est pas la peine d'y indiquer la matière éventuelle puisqu'elle est mentionnée sur cette page.</p>
    <p>Le <em>préfixe</em> est un nom court qui servira de préfixe aux fichiers récupérés, qui seront automatiquement renommés sous la forme <code>prefixe&nbsp;-&nbsp;nom&nbsp;prénom</code>. Il vaut mieux mettre un nom court, les espaces sont autorisés. Par exemple, «&nbsp;DM9&nbsp;» ou «&nbsp;CR colle&nbsp;12&nbsp;».</p>
    <p>Le <em>sens du transfert</em> et les <em>encadrants concernés</em> sont les deux réglages d'accès au transfert (voir les détails ci-dessous).</p>
    <p>La <em>date limite d'envoi</em> correspond à la date-heure jusqu'à laquelle les élèves ou les encadrants peuvent envoyer des documents, selon le sens du transfert. Une fois cette date dépassée, plus aucun nouveau document ne peut être envoyé, mais le transfert continue d'apparaître et les documents continuent d'être téléchargeables par les élèves et les encadrants concernés.</p>
    <p>La <em>date de disponibilité</em> correspond à la date-heure à laquelle le transfert sera visible pour les élèves. Avant cette date-là, il est invisible pour eux. Mais pour tous les encadrants autorisés, le transfert n'est jamais invisible. </p>
    <p>Valider une <em>disponibilité</em> vide rend le transfert visible par les élèves immédiatement.</p>
    <p>La date limite d'envoi est nécessairement ultérieure à la date de disponibilité.</p>
    <p>Les <em>indications visibles pour les élèves</em> sont les indications que vous pouvez donner à vos élèves. Grâce aux boutons d'édition, vous pouvez formatter ce texte et ajouter des liens vers les autres pages du site, vers des documents du site, vers d'autres pages sur le web... L'insertion de ressources de type image, pdf ou vidéo, est aussi possible. Par exemple, vous pouvez positionner un sujet dans les <em>Documents à télécharger</em>, avec affichage différé, et mettre le lien ici.</p>
    <p>Les <em>indications</em> ne sont pas obligatoires.</p>
    <h4>Possibilités de téléchargement</h4>
    <p>Quel que soit le sens du transfert, les professeurs ont la possibilité de télécharger tous les documents. Quel que soit le sens du transfert, les élèves ne peuvent télécharger que les documents qui les concernent explicitement. Un document ne peut pas concerner deux élèves ou plus.</p>
    <p>Si le transfert est dans le sens élèves vers encadrants, l'ensemble des encadrants autorisés peuvent télécharger tous les documents envoyés par les élèves. Les documents ne sont pas fléchés vers un encadrant spécifique.</p>
    <p>Si le transfert est dans le sens encadrants vers élèves, chaque encadrant ne peut télécharger que les documents qu'il a envoyés.</p>
    <p>Les documents téléchargés sont éventuellement regroupés dans un fichier <code>zip</code>. Ils sont systématiquement renommés pour faire apparaître le nom du transfert et le nom de l'élève. Si, dans un même transfert, plusieurs documents correspondent à un seul élève, ils sont de plus numérotés.</p>
  </div>

  <div id="aide-voirtout">
    <h3>Aide et explications</h3>
    <p>Ce formulaire permet de voir la liste des documents envoyés sur le transfert choisi. Il ne permet pas de modifier le transfert lui-même, et se ferme en cliquant sur <span class="icon-ferme"></span>.</p>
    <p>Cette liste est classable selon l'ordre alphabétique des noms d'élèves ou l'heure d'envoi des documents à l'aide des boutons <span class="icon-chronodesc"></span>,<span class="icon-chronoasc"></span>,<span class="icon-alphadesc"></span>,<span class="icon-alphaasc"></span>.</p>
    <p>Il est possible de recharger cette liste instantanément à l'aide du bouton <span class="icon-actualise"></span>. Il n'y a pas de délai entre l'envoi du document par un élève et l'apparition dans cette liste&nbsp;: ce bouton permet immédiatement de vérifier qu'un élève dit vrai quand il assure avoir envoyé son document...</p>
    <h4>Action sur les documents</h4>
    <p>Chaque document auquel vous avez accès (voir ci-dessous) est téléchargeable avec le bouton <span class="icon-download"></span> et supprimable avec le bouton <span class="icon-supprime"></span> situés sur sa ligne. </p>
    <p>Les documents téléchargés sont systématiquement renommés pour faire apparaître le préfixe du transfert et le nom-prénom de l'élève. Si, dans un même transfert, plusieurs documents correspondent à un seul élève, ils sont de plus numérotés.</p>
    <p>Il est possible de télécharger ou supprimer plusieurs documents simultanément en les cochant et en utilisant les boutons <span class="icon-download"></span> et <span class="icon-supprime"></span> situés en haut du tableau. Il est possible de cocher tous les documents en un seul clic sur le bouton <span class="icon-cocher"></span>. Les documents sont alors regroupés dans un fichier <code>zip</code>.</p>
    <h4>Possibilités de téléchargement</h4>
    <p>Quel que soit le sens du transfert, les professeurs ont la possibilité de télécharger tous les documents. Quel que soit le sens du transfert, les élèves ne peuvent télécharger que les documents qui les concernent explicitement. Un document ne peut pas concerner deux élèves ou plus.</p>
    <p>Si le transfert est dans le sens élèves vers encadrants, l'ensemble des encadrants autorisés peuvent télécharger tous les documents envoyés par les élèves. Les documents ne sont pas fléchés vers un encadrant spécifique.</p>
    <p>Si le transfert est dans le sens encadrants vers élèves, chaque encadrant ne peut télécharger que les documents qu'il a envoyés.</p>
  </div>

  <div id="aide-ajoutetransdocs">
    <h3>Aide et explications</h3>
    <p>Ce formulaire permet d'envoyer simultanément plusieurs documents personnels. Il sera validé par un clic sur <span class="icon-ok"></span>, et abandonné (donc supprimé) par un clic sur <span class="icon-ferme"></span>.</p>
    <p>En cliquant sur le bouton de chargement des fichiers, une fenêtre gérée par votre navigateur va s'ouvrir. Vous pourrez y choisir autant de documents que vous souhaitez, par exemple en appuyant sur la touche <code>Ctrl</code> tout en cliquant sur les documents.</p>
    <p>La taille maximale de l'ensemble des documents envoyés est <?php echo $taille; ?>.</p>
    <p>Après validation des documents choisis, autant de cases appraîtront pour permettre l'affectation de chaque document à un élève.</p> 
    <p>Une proposition d'affection est automatiquement réalisée, avant l'envoi définitif des documents, par l'analyse des noms des documents. Si un nom de document comporte un nom ou un nom-prénom d'élève, il lui est affecté. Les documents non affectés sont affichés en rouge. Les proposition sont encore modifiable avant l'envoi définitif réalisé par le bouton <span class="icon-ok"></span>.</p>
    <p>Une affectation de document à un élève n'est pas modifiable après envoi. En cas d'erreur, il faut supprimer le document et le renvoyer.</p>
    <p>Aucune annonce automatique n'est faite aux élèves lorsqu'un document est envoyé à un élève. Il est donc préférable de prévenir les élèves, par exemple par mail, lorsque des documents personnels importants leur sont envoyés.</p>
  </div>


<?php
// Les colleurs et comptes lycée doivent pouvoir faire des actions sur les transferts existants.
fin(true,$mathjax,$edition ? 'datetimepicker' : '');
?>
